import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Timer;

class GameWindow extends JFrame {
	private Canvas cGame = new Canvas() {
		public void paint(Graphics g) {
			drawLevel();
		}
	};
	
	private Timer t;
	
	private Snake s;
	private GUIUpdater g;
	private GameLoop gl;
	
	public GameWindow() {
		cGame.setSize(960,540);
		s = new Snake(new Coord(1,1,0));
		s.setHeadTexture(1000);
		setLayout(new BorderLayout());
		add(cGame, BorderLayout.CENTER);
		pack();
		setTitle("\"Jippy Snake 8\" pre-Alpha");
		setVisible(true);
		g = new GUIUpdater(cGame);
		//g.setLevel(new JS8Level("levels/test.xml"));
		//g.setSnake(s);
		//g.drawLevel();
		cGame.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				System.out.println("drawing...");
				drawLevel();
			}
		});
		
		cGame.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_UP)
					turn(0,-1);
				else if (e.getKeyCode() == KeyEvent.VK_DOWN)
					turn(0,1);
				else if (e.getKeyCode() == KeyEvent.VK_LEFT)
					turn(-1,0);
				else if (e.getKeyCode() == KeyEvent.VK_RIGHT)
					turn(1,0);
			}
		});
		gl = new GameLoop(g);
		t = new Timer();
		t.schedule(gl,0,250);
		cGame.requestFocus();
	}
	
	private void drawLevel() {
		if (g != null) {
			g.draw(false, false);
		}
	}
	
	private void turn(int x, int y) {
		gl.setDir(new Coord(x,y));
	}
	public static void main(String[] args) {
		Globals.init();
		GameWindow gw = new GameWindow();
	}
} 
