/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */

import java.util.Vector;

class SnakeBody {
	private Vector<SnakeElement> elements;
	private SnakeElement curElem;
	
	public SnakeBody() {
		elements = new Vector<SnakeElement>();
		curElem = null;
	}
	
	//moves the snakebody
	public void move(Coord headPos) {
		if (curElem == null) return;
		curElem.setPos(headPos);
		curElem = curElem.getNext();
	}
	
	//adds an element, the added element will be moved next time
	public void addElement(Coord pos) {
		if (curElem == null) {
			elements.add(new SnakeElement(pos, 1));
			curElem = elements.elementAt(0);
		} else {
			elements.add(new SnakeElement(pos,curElem, 1));
			curElem = curElem.getPrev();
		}
	}
	
	//Sets the texure of element, that was moves this time
	public void setTexture(int text) {
		if (curElem != null)
			curElem.setTexture(text);
	}

	//Sets the texure of element, that was moves this time
	public void setPrevTexture(int text) {
		if (curElem != null)
			curElem.getPrev().setTexture(text);
	}
	
	//Gets position of element, taht was moved this time
	public Coord getPos() {
		if (curElem != null)
			return curElem.getPos();
		else return null;
	}
	
	//Gets the positon of element, that was moved last time
	public Coord getPrevPos() {
		if (curElem != null)
			return curElem.getPrev().getPos();
		else return null;
	}

	//Gets the positon of element, that was moved last time
	public Coord getPrevPrevPos() {
		if (curElem != null)
			return curElem.getPrev().getPrev().getPos();
		else return null;
	}
	
	//Gets position of element, that will bemmoved next time
	public Coord getNextPos() {
		if (curElem != null)
			return curElem.getNext().getPos();
		else return null;
	}
	
	//returns a vector with all elements
	public Vector<SnakeElement> getSnakeElements() {
		return elements;
	}
}